Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -4525,24 +4499,24 @@
                   !! ROAM provisionally has access to a further 20 2D diagnostics
                   if (jk .eq. 1) then
-                     trc2d(ji,jj,91)  = trc2d(ji,jj,91)  + f_wind              !! surface wind
-                     trc2d(ji,jj,92)  = trc2d(ji,jj,92)  + f_pco2atm           !! atmospheric pCO2
-                     trc2d(ji,jj,93)  = trc2d(ji,jj,93)  + f_ph                !! ocean pH
-                     trc2d(ji,jj,94)  = trc2d(ji,jj,94)  + f_pco2w             !! ocean pCO2
-                     trc2d(ji,jj,95)  = trc2d(ji,jj,95)  + f_h2co3             !! ocean H2CO3 conc.
-                     trc2d(ji,jj,96)  = trc2d(ji,jj,96)  + f_hco3              !! ocean HCO3 conc.
-                     trc2d(ji,jj,97)  = trc2d(ji,jj,97)  + f_co3               !! ocean CO3 conc.
-                     trc2d(ji,jj,98)  = trc2d(ji,jj,98)  + f_co2flux           !! air-sea CO2 flux
+                     trc2d(ji,jj,91)  = trc2d(ji,jj,91)  + wndm(ji,jj)              !! surface wind
+                     trc2d(ji,jj,92)  = trc2d(ji,jj,92)  + f_pco2atm(ji,jj)           !! atmospheric pCO2
+                     trc2d(ji,jj,93)  = trc2d(ji,jj,93)  + f_ph(ji,jj)                !! ocean pH
+                     trc2d(ji,jj,94)  = trc2d(ji,jj,94)  + f_pco2w(ji,jj)             !! ocean pCO2
+                     trc2d(ji,jj,95)  = trc2d(ji,jj,95)  + f_h2co3(ji,jj)             !! ocean H2CO3 conc.
+                     trc2d(ji,jj,96)  = trc2d(ji,jj,96)  + f_hco3(ji,jj)              !! ocean HCO3 conc.
+                     trc2d(ji,jj,97)  = trc2d(ji,jj,97)  + f_co3(ji,jj)               !! ocean CO3 conc.
+                     trc2d(ji,jj,98)  = trc2d(ji,jj,98)  + f_co2flux(ji,jj)           !! air-sea CO2 flux
                      trc2d(ji,jj,99)  = trc2d(ji,jj,99)  + f_omcal(ji,jj)      !! ocean omega calcite 
                      trc2d(ji,jj,100) = trc2d(ji,jj,100) + f_omarg(ji,jj)      !! ocean omega aragonite
-                     trc2d(ji,jj,101) = trc2d(ji,jj,101) + f_TDIC              !! ocean TDIC
-                     trc2d(ji,jj,102) = trc2d(ji,jj,102) + f_TALK              !! ocean TALK
-                     trc2d(ji,jj,103) = trc2d(ji,jj,103) + f_kw660             !! surface kw660
-                     trc2d(ji,jj,104) = trc2d(ji,jj,104) + f_pp0               !! surface pressure
-                     trc2d(ji,jj,105) = trc2d(ji,jj,105) + f_o2flux            !! air-sea O2 flux
-                     trc2d(ji,jj,106) = trc2d(ji,jj,106) + f_o2sat             !! ocean O2 saturation
+                     trc2d(ji,jj,101) = trc2d(ji,jj,101) + f_TDIC(ji,jj)              !! ocean TDIC
+                     trc2d(ji,jj,102) = trc2d(ji,jj,102) + f_TALK(ji,jj)              !! ocean TALK
+                     trc2d(ji,jj,103) = trc2d(ji,jj,103) + f_kw660(ji,jj)             !! surface kw660
+                     trc2d(ji,jj,104) = trc2d(ji,jj,104) + f_pp0(ji,jj)               !! surface pressure
+                     trc2d(ji,jj,105) = trc2d(ji,jj,105) + f_o2flux(ji,jj)            !! air-sea O2 flux
+                     trc2d(ji,jj,106) = trc2d(ji,jj,106) + f_o2sat(ji,jj)             !! ocean O2 saturation
                      trc2d(ji,jj,107) = f2_ccd_cal(ji,jj)                      !! depth calcite CCD
                      trc2d(ji,jj,108) = f2_ccd_arg(ji,jj)                      !! depth aragonite CCD
                   endif
-                  if (jk .eq. jmbathy) then
+                  if (jk .eq. mbathy(ji,jj)) then
                      trc2d(ji,jj,109) = f3_omcal(ji,jj,jk)                     !! seafloor omega calcite
                      trc2d(ji,jj,110) = f3_omarg(ji,jj,jk)                     !! seafloor omega aragonite
@@ -4553,5 +4527,5 @@
                   if (jk.eq.i1000) trc2d(ji,jj,120) = ffastca(ji,jj)/MAX(ffastc(ji,jj), rsmall)  !! rain ratio at 1000 m
                   !! AXY (18/01/12): benthic flux diagnostics
-                  if (jk.eq.jmbathy) then
+                  if (jk.eq.mbathy(ji,jj)) then
                      trc2d(ji,jj,121) = f_sbenin_n(ji,jj)  + f_fbenin_n(ji,jj)
                      trc2d(ji,jj,122) = f_sbenin_fe(ji,jj) + f_fbenin_fe(ji,jj)
@@ -4568,9 +4542,9 @@
                   trc2d(ji,jj,136) = f_runoff(ji,jj)
                   !! AXY (19/07/12): amended to allow for riverine nutrient addition below surface
-                  trc2d(ji,jj,137) = trc2d(ji,jj,137) + (f_riv_loc_n * fthk)
-                  trc2d(ji,jj,138) = trc2d(ji,jj,138) + (f_riv_loc_si * fthk)
-                  trc2d(ji,jj,139) = trc2d(ji,jj,139) + (f_riv_loc_c * fthk)
-                  trc2d(ji,jj,140) = trc2d(ji,jj,140) + (f_riv_loc_alk * fthk)
-                  trc2d(ji,jj,141) = trc2d(ji,jj,141) + (fslowc  * fthk)       !! slow sinking detritus C production
+                  trc2d(ji,jj,137) = trc2d(ji,jj,137) + (f_riv_loc_n(ji,jj) * fse3t(ji,jj,jk))
+                  trc2d(ji,jj,138) = trc2d(ji,jj,138) + (f_riv_loc_si(ji,jj) * fse3t(ji,jj,jk))
+                  trc2d(ji,jj,139) = trc2d(ji,jj,139) + (f_riv_loc_c(ji,jj) * fse3t(ji,jj,jk))
+                  trc2d(ji,jj,140) = trc2d(ji,jj,140) + (f_riv_loc_alk(ji,jj) * fse3t(ji,jj,jk))
+                  trc2d(ji,jj,141) = trc2d(ji,jj,141) + (fslowc(ji,jj)  * fse3t(ji,jj,jk))       !! slow sinking detritus C production
                   if (jk.eq.i0100) trc2d(ji,jj,142) = fslowcflux(ji,jj)        !! slow detritus flux at  100 m
                   if (jk.eq.i0200) trc2d(ji,jj,143) = fslowcflux(ji,jj)        !! slow detritus flux at  200 m
@@ -4580,8 +4554,8 @@
                   trc2d(ji,jj,147)  = trc2d(ji,jj,147)  + ftot_a(ji,jj)        !! alkalinity inventory
                   trc2d(ji,jj,148)  = trc2d(ji,jj,148)  + ftot_o2(ji,jj)       !! oxygen     inventory
-                  if (jk.eq.jmbathy) then
+                  if (jk.eq.mbathy(ji,jj)) then
                      trc2d(ji,jj,149) = f_benout_lyso_ca(ji,jj)
                   endif
-                  trc2d(ji,jj,150) = fcomm_resp(ji,jj) * fthk                  !! community respiration
+                  trc2d(ji,jj,150) = fcomm_resp(ji,jj) * fse3t(ji,jj,jk)                  !! community respiration
 		  !!
 		  !! AXY (14/02/14): a Valentines Day gift to BASIN - a shedload of new
@@ -4593,49 +4567,49 @@
                   !! linear losses
                   !! non-diatom
-                  trc2d(ji,jj,151) = trc2d(ji,jj,151) + (fdpn2  * fthk)
+                  trc2d(ji,jj,151) = trc2d(ji,jj,151) + (fdpn2(ji,jj)  * fse3t(ji,jj,jk))
                   !! diatom
-                  trc2d(ji,jj,152) = trc2d(ji,jj,152) + (fdpd2  * fthk)
+                  trc2d(ji,jj,152) = trc2d(ji,jj,152) + (fdpd2(ji,jj)  * fse3t(ji,jj,jk))
                   !! microzooplankton
-                  trc2d(ji,jj,153) = trc2d(ji,jj,153) + (fdzmi2 * fthk)
+                  trc2d(ji,jj,153) = trc2d(ji,jj,153) + (fdzmi2(ji,jj) * fse3t(ji,jj,jk))
                   !! mesozooplankton
-                  trc2d(ji,jj,154) = trc2d(ji,jj,154) + (fdzme2 * fthk)
+                  trc2d(ji,jj,154) = trc2d(ji,jj,154) + (fdzme2(ji,jj) * fse3t(ji,jj,jk))
                   !! ----------------------------------------------------------------------
                   !! microzooplankton grazing
                   !! microzooplankton messy -> N
-                  trc2d(ji,jj,155) = trc2d(ji,jj,155) + (xphi * (fgmipn + fgmid) * fthk)
+                  trc2d(ji,jj,155) = trc2d(ji,jj,155) + (xphi * (fgmipn(ji,jj) + fgmid(ji,jj)) * fse3t(ji,jj,jk))
                   !! microzooplankton messy -> D
-                  trc2d(ji,jj,156) = trc2d(ji,jj,156) + ((1. - xbetan) * finmi * fthk)
+                  trc2d(ji,jj,156) = trc2d(ji,jj,156) + ((1. - xbetan) * finmi(ji,jj) * fse3t(ji,jj,jk))
                   !! microzooplankton messy -> DIC
-                  trc2d(ji,jj,157) = trc2d(ji,jj,157) + (xphi * ((xthetapn * fgmipn) + fgmidc) * fthk)
+                  trc2d(ji,jj,157) = trc2d(ji,jj,157) + (xphi * ((xthetapn * fgmipn(ji,jj)) + fgmidc(ji,jj)) * fse3t(ji,jj,jk))
                   !! microzooplankton messy -> Dc
-                  trc2d(ji,jj,158) = trc2d(ji,jj,158) + ((1. - xbetac) * ficmi * fthk)
+                  trc2d(ji,jj,158) = trc2d(ji,jj,158) + ((1. - xbetac) * ficmi(ji,jj) * fse3t(ji,jj,jk))
                   !! microzooplankton excretion
-                  trc2d(ji,jj,159) = trc2d(ji,jj,159) + (fmiexcr * fthk)
+                  trc2d(ji,jj,159) = trc2d(ji,jj,159) + (fmiexcr(ji,jj) * fse3t(ji,jj,jk))
                   !! microzooplankton respiration
-                  trc2d(ji,jj,160) = trc2d(ji,jj,160) + (fmiresp * fthk)
+                  trc2d(ji,jj,160) = trc2d(ji,jj,160) + (fmiresp(ji,jj) * fse3t(ji,jj,jk))
                   !! microzooplankton growth
-                  trc2d(ji,jj,161) = trc2d(ji,jj,161) + (fmigrow * fthk)
+                  trc2d(ji,jj,161) = trc2d(ji,jj,161) + (fmigrow(ji,jj) * fse3t(ji,jj,jk))
                   !! ----------------------------------------------------------------------
                   !! mesozooplankton grazing
                   !! mesozooplankton messy -> N
-                  trc2d(ji,jj,162) = trc2d(ji,jj,162) + (xphi * (fgmepn + fgmepd + fgmezmi + fgmed) * fthk)
+                  trc2d(ji,jj,162) = trc2d(ji,jj,162) + (xphi * (fgmepn(ji,jj) + fgmepd(ji,jj) + fgmezmi(ji,jj) + fgmed(ji,jj)) * fse3t(ji,jj,jk))
                   !! mesozooplankton messy -> D
-                  trc2d(ji,jj,163) = trc2d(ji,jj,163) + ((1. - xbetan) * finme * fthk)
+                  trc2d(ji,jj,163) = trc2d(ji,jj,163) + ((1. - xbetan) * finme(ji,jj) * fse3t(ji,jj,jk))
                   !! mesozooplankton messy -> DIC
-                  trc2d(ji,jj,164) = trc2d(ji,jj,164) + (xphi * ((xthetapn * fgmepn) + (xthetapd * fgmepd) + &
-                  &                  (xthetazmi * fgmezmi) + fgmedc) * fthk)
+                  trc2d(ji,jj,164) = trc2d(ji,jj,164) + (xphi * ((xthetapn * fgmepn(ji,jj)) + (xthetapd * fgmepd(ji,jj)) + &
+                  &                  (xthetazmi * fgmezmi(ji,jj)) + fgmedc(ji,jj)) * fse3t(ji,jj,jk))
                   !! mesozooplankton messy -> Dc
-                  trc2d(ji,jj,165) = trc2d(ji,jj,165) + ((1. - xbetac) * ficme * fthk)
+                  trc2d(ji,jj,165) = trc2d(ji,jj,165) + ((1. - xbetac) * ficme(ji,jj) * fse3t(ji,jj,jk))
                   !! mesozooplankton excretion
-                  trc2d(ji,jj,166) = trc2d(ji,jj,166) + (fmeexcr * fthk)
+                  trc2d(ji,jj,166) = trc2d(ji,jj,166) + (fmeexcr(ji,jj) * fse3t(ji,jj,jk))
                   !! mesozooplankton respiration
-                  trc2d(ji,jj,167) = trc2d(ji,jj,167) + (fmeresp * fthk)
+                  trc2d(ji,jj,167) = trc2d(ji,jj,167) + (fmeresp(ji,jj) * fse3t(ji,jj,jk))
                   !! mesozooplankton growth
-                  trc2d(ji,jj,168) = trc2d(ji,jj,168) + (fmegrow * fthk)
+                  trc2d(ji,jj,168) = trc2d(ji,jj,168) + (fmegrow(ji,jj) * fse3t(ji,jj,jk))
                   !! ----------------------------------------------------------------------
                   !! miscellaneous
-                  trc2d(ji,jj,169) = trc2d(ji,jj,169) + (fddc    * fthk) !! detrital C remineralisation
-                  trc2d(ji,jj,170) = trc2d(ji,jj,170) + (fgmidc  * fthk) !! microzoo grazing on detrital carbon
-                  trc2d(ji,jj,171) = trc2d(ji,jj,171) + (fgmedc  * fthk) !! mesozoo  grazing on detrital carbon
+                  trc2d(ji,jj,169) = trc2d(ji,jj,169) + (fddc(ji,jj)    * fse3t(ji,jj,jk)) !! detrital C remineralisation
+                  trc2d(ji,jj,170) = trc2d(ji,jj,170) + (fgmidc(ji,jj)  * fse3t(ji,jj,jk)) !! microzoo grazing on detrital carbon
+                  trc2d(ji,jj,171) = trc2d(ji,jj,171) + (fgmedc(ji,jj)  * fse3t(ji,jj,jk)) !! mesozoo  grazing on detrital carbon
                   !!
                   !! ----------------------------------------------------------------------
@@ -4646,43 +4620,4 @@
 		  !!                 below this section)
 		  !!
-		  !! extract fields at surface
-		 !! if (jk .eq. 1) then
-                 !!    trc2d(ji,jj,172) = zchn              !! Pn chlorophyll
-                 !!    trc2d(ji,jj,173) = zphn              !! Pn biomass
-                 !!    trc2d(ji,jj,174) = fjln              !! Pn J-term
-                 !!    trc2d(ji,jj,175) = (fprn * zphn)     !! Pn PP
-                 !!    trc2d(ji,jj,176) = zchd              !! Pd chlorophyll
-                 !!    trc2d(ji,jj,177) = zphd              !! Pd biomass
-                 !!    trc2d(ji,jj,178) = fjld              !! Pd J-term
-                 !!    trc2d(ji,jj,179) = xpar(ji,jj,jk)    !! Pd PP
-                 !!    trc2d(ji,jj,180) = loc_T             !! local temperature
-                 !! endif
-		 !! !!
-		 !! !! extract fields at 50m (actually 44-50m)
-		 !! if (jk .eq. 18) then
-                 !!    trc2d(ji,jj,181) = zchn              !! Pn chlorophyll
-                 !!    trc2d(ji,jj,182) = zphn              !! Pn biomass
-                 !!    trc2d(ji,jj,183) = fjln              !! Pn J-term
-                 !!    trc2d(ji,jj,184) = (fprn * zphn)     !! Pn PP
-                 !!    trc2d(ji,jj,185) = zchd              !! Pd chlorophyll
-                 !!    trc2d(ji,jj,186) = zphd              !! Pd biomass
-                 !!    trc2d(ji,jj,187) = fjld              !! Pd J-term
-                 !!    trc2d(ji,jj,188) = xpar(ji,jj,jk)    !! Pd PP
-                 !!    trc2d(ji,jj,189) = loc_T             !! local temperature
-                 !! endif
-		 !! !!
-		 !! !! extract fields at 100m
-		 !! if (jk .eq. i0100) then
-                 !!    trc2d(ji,jj,190) = zchn              !! Pn chlorophyll
-                 !!    trc2d(ji,jj,191) = zphn              !! Pn biomass
-                 !!    trc2d(ji,jj,192) = fjln              !! Pn J-term
-                 !!    trc2d(ji,jj,193) = (fprn * zphn)     !! Pn PP
-                 !!    trc2d(ji,jj,194) = zchd              !! Pd chlorophyll
-                 !!    trc2d(ji,jj,195) = zphd              !! Pd biomass
-                 !!    trc2d(ji,jj,196) = fjld              !! Pd J-term
-                 !!    trc2d(ji,jj,197) = xpar(ji,jj,jk)    !! Pd PP
-                 !!    trc2d(ji,jj,198) = loc_T             !! local temperature
-                 !! endif
-                 !!
                   !! extract relevant BASIN fields at 150m
                   if (jk .eq. i0150) then
@@ -4738,10 +4673,10 @@
                   !!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
                   if ((jk .eq. 1) .and.( jdms.eq.1)) then
-                     trc2d(ji,jj,221) = dms_surf          !! DMS surface concentration 
+                     trc2d(ji,jj,221) = dms_surf(ji,jj)          !! DMS surface concentration 
                      !! AXY (13/03/15): add in other DMS estimates
-                     trc2d(ji,jj,222) = dms_andr          !! DMS surface concentration 
-                     trc2d(ji,jj,223) = dms_simo          !! DMS surface concentration 
-                     trc2d(ji,jj,224) = dms_aran          !! DMS surface concentration 
-                     trc2d(ji,jj,225) = dms_hall          !! DMS surface concentration 
+                     trc2d(ji,jj,222) = dms_andr(ji,jj)          !! DMS surface concentration 
+                     trc2d(ji,jj,223) = dms_simo(ji,jj)          !! DMS surface concentration 
+                     trc2d(ji,jj,224) = dms_aran(ji,jj)          !! DMS surface concentration 
+                     trc2d(ji,jj,225) = dms_hall(ji,jj)          !! DMS surface concentration 
                   endif
 # endif
@@ -4756,7 +4691,7 @@
                   !!----------------------------------------------------------------------
                   !!
-                  trc3d(ji,jj,jk,1)  = ((fprn + fprd) * zphn)     !! primary production  
+                  trc3d(ji,jj,jk,1)  = ((fprn(ji,jj) + fprd(ji,jj)) * zphn(ji,jj))     !! primary production  
                   trc3d(ji,jj,jk,2)  = fslownflux(ji,jj) + ffastn(ji,jj) !! detrital flux
-                  trc3d(ji,jj,jk,3)  = fregen + (freminn * fthk)  !! remineralisation
+                  trc3d(ji,jj,jk,3)  = fregen(ji,jj) + (freminn(ji,jj) * fse3t(ji,jj,jk))  !! remineralisation
 # if defined key_roam
                   trc3d(ji,jj,jk,4)  = f3_pH(ji,jj,jk)            !! pH
